//+------------------------------------------------------------------+
//|                                                  MACD Sample.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
extern double Lots = 0.1;
extern double TakeProfit = 90;
extern double TrailingStop  =15;
extern double MACDOpenLevel =0;
extern double MACDCloseLevel=0;
extern double MATrendPeriod =26;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//------------------------------------------
extern int FastEMA   = 1;
extern int SlowEMA   = 3;
extern int SignalSMA = 4;
//------------------------------ the names of variables for the optimization---------------------
string Per1          = "FastEMA";
string Per2          = "SlowEMA";
string Per3          = "TakeProfit";
string Per4          = "TrailingStop";
//-------------------------------------------
extern double TimeTest = 23.45;             //the starting time of the optimization
extern int TestDay     = 5;                 //a quantity of days for the testing
int Flag;
double   pointvalue;
//-------------------------------------------

#import  "shell32.dll"                       //let us connect dll (it enters into composition Windows)       
  int ShellExecuteA(int hwnd,string lpOperation,string lpFile,string lpParameters,string lpDirectory,int nShowCmd); 
#import
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int init()
{

if (Digits == 4 || Digits == 2) pointvalue = Point;
else if (Digits == 5 || Digits == 3) pointvalue = Point*10;



if(!IsOptimization()||!IsTesting())                                       //     
  { 
   Tester();                                                              //     
  } 
return(0);
}
//"C:\Program Files\Demo\Interbank FX Trader 4\terminal.exe"
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//--------------------------------------- the local variables -----------------------------------------------------
void Tester()
    {
string NameMTS         = "MACD Sample2.1";                                 //the name of the adviser
string NameFileSet     = "MACDSample2.1.set";                              //the name of set of file for the tester
string PathTerminal    = TerminalPath()+"\experts\files";                  //way to the terminal  
string PathTester      = "C:\Program Files\Demo\Interbank FX Trader 4";      //way to the tester
string FileOptim       = "optimise.ini";                                   //the name of ini of file for the tester
string FileOptim1      = "\optimise.ini";                                  
datetime DeyStart      = TimeLocal()-86400*TestDay;                        //the calculation of the starting date
datetime DeyStop       = TimeLocal();                                      //the calculation of the starting date
string DateStart       = TimeToStr(DeyStart,TIME_DATE);                    //the date of [napchala] of the optimization
string DateStop        = TimeToStr(DeyStop,TIME_DATE);                     //the date of the end of the optimization
string FileReport      = "FileReport_"+Symbol()+"_"+DateStop+".htm";       //the name of the file of the report of the tester
string FileReport1     = "\FileReport_"+Symbol()+"_"+DateStop+".htm";
int    KvoPptk         = 10;                                               //a quantity of the attempts to copy the file of the report
int    TimeOut         = TestDay*35000;  // (it flogged * [kvo] of days)                 Waiting time of the end of the work of the optimizer
//-------------------------------- the auto-installation of the period ------------------------------
string Per;

if(Period()==PERIOD_M1) {Per = "M1";}
if(Period()==PERIOD_M5) {Per = "M5";}
if(Period()==PERIOD_M15){Per = "M15";}
if(Period()==PERIOD_M30){Per = "M30";}
if(Period()==PERIOD_H1) {Per = "H1";}
if(Period()==PERIOD_H4) {Per = "H4";}

//------------------------ let us arrange the priorities of the filtration ----------------------------
double MinTrades       = TestDay-3;                                        //a minimum quantity of the transactions
int Gross_Profit       = 3;                                                //the general profit
int Profit_Factor      = 1;                                                //the profitableness
int Expected_Payoff    = 2;                                                //mat is the expectation
 //----------------------
int StepRes            = TestDay*10;                                       //a quantity of lines for the sorting

//-------------------------------other intermediate variables------------------------
int    copyini;
int    start;
int    opttim;
int    file;
int    Pptk;
int    OptimArraySize;
int    P1,P2,P3,P4,P1k,P2k,P3k,P4k;
int    ClStep,ClStepRazm,GrProf,GrProfRazm,TotTrad,TotTradRazm,ProfFact,ProfFactRazm,ExpPay,ExpPayRazm;
int    text;
int    index;
int    kol;
int    NumberStr;
int    NumStr;
int    test;
int    GrosPr;
int    ResizeArayNew;
int    PrCycle;

double kol1,kol2,kol3,kol4,kol5,kol6,kol7,kol8,kol9;
double TotalTradesTransit;
double PrFactDouble;
double Prior1, Prior2, Prior3, transit, transit1, transit2, transit3, transit4;
double NewPrior, NewPrior1, NewPrior2, NewPrior3, Sort, SortTrans;

string FileLine; 
string ini;
string CycleStep,GrossProfit,TotalTrades,ProfitFactor,ExpectedPayoff;
string Perem1,Perem2,Perem3,Perem4; 
string select;

//----------------------------------- let us prepare the massifs -------------------------
string ArrayOpttim[15]; 
string ArrayStrg[10]; 
double ArrayData[10][9]; 
double ArrayTrans[10][9];

//------------------------------let us prepare ini file for the optimization----------------
                           
           ArrayOpttim[0] = ";optimise strategy tester";             
           ArrayOpttim[1] = "ExpertsEnable=false";                        //vkl/the Off experts
           ArrayOpttim[2] = "TestExpert="+NameMTS;                        //the designation of the file of the expert
           ArrayOpttim[3] = "TestExpertParameters="+NameFileSet;          //the designation of file with the parameters
           ArrayOpttim[4] = "TestSymbol="+Symbol();                       //the tool
           ArrayOpttim[5] = "TestPeriod="+Per;                            //the period
           ArrayOpttim[6] = "TestModel=0";                                //the regime of the simulation
           ArrayOpttim[7] = "TestRecalculate=true";                       //to recount
           ArrayOpttim[8] = "TestOptimization=true";                      //the optimization
           ArrayOpttim[9] = "TestDateEnable=true";                        //to use the date
           ArrayOpttim[10]= "TestFromDate="+DateStart;                    //the date of the beginning of the testing
           ArrayOpttim[11]= "TestToDate="+DateStop;                       //the date of the end of the testing
           ArrayOpttim[12]= "TestReport="+FileReport;                     //the name of the file of the report
           ArrayOpttim[13]= "TestReplaceReport=true";                     //the rerecording of the file of the report
           ArrayOpttim[14]= "TestShutdownTerminal=true";                  //to shut terminal on the completion
           
//------------------------------- let us write down data into ini the file --------------------------                 
  
  OptimArraySize=ArraySize(ArrayOpttim);                                  //let us explain the size of the massif
  opttim=FileOpen(FileOptim,FILE_CSV|FILE_WRITE,0x7F);                    //let us open halyard for the record
  if(opttim>0)
    {
     for(int i=0; i<OptimArraySize; i++)
        {
         ini=ArrayOpttim[i];                                              //from the massif in the variable
         FileWrite(opttim, ini);                                          //from the variable into the file
        } 
         FileClose(opttim);                                               //let us shut the file
    }
  
//-------------------------- let us copy ini file into the sandbox of the tester ----------
    copyini = ShellExecuteA(0,"Open","xcopy","\""+PathTerminal+FileOptim1+"\" \""+PathTester+"\" /y","",3);
    Sleep(1000);                                                   //let us wait the second
    if(copyini<0){Alert("it was impossible to copy ini file");Print("it was impossible to copy ini file"+FileOptim);return(0);}
   
//---------------------------------- let us neglect the tester -------------------------
    start   = ShellExecuteA(0,"Open","terminal.exe",FileOptim,PathTester,3);
    if( start<0){Print("It [neudalos] to neglect tester "); return(0);}
//------------------------ let us copy the file of report into the sandbox of the terminal-------
     Sleep(TimeOut);                                              //let us wait the end of the optimization
     for(Pptk=0;Pptk<KvoPptk;Pptk++)
         {
          ShellExecuteA(0,"Open","xcopy","\""+PathTester+FileReport1+"\" \""+PathTerminal+"\" /y","",3);
          Sleep(6000);                                             //let us wait
          file=FileOpen(FileReport,FILE_READ,0x7F);                //let us open the file of report for reading
             
          if(file<0)
            {  
             Sleep(6000);                                          //still let us wait
            }
          else break;             
          }
      if(file<0){Alert("it was impossible to copy the file of report");Print("it was impossible to copy the file of report"+FileReport);return(0);}
 
//---------------- reading from the file into the massif----------------------------------
   while(FileIsEnding(file)==false)                                //thus far did not begin the end of the file - cycle
        {
         FileLine=FileReadString(file);                            //let us read line from the file of the report
         index=StringFind(FileLine, "title", 20);                  //let us find necessary line and will establish starting point
         if(index>0)
              {
               ArrayResize(ArrayStrg,NumStr+1);                    //we increase the size of the massif
               ArrayStrg[NumStr]=FileLine;                         //we write into the massif of line from the file
               NumStr++;
              }
          }
          
    FileClose(file);                                               //let us shut the file
    FileDelete(FileReport);                                        //let us remove file in order not to procreate the copy
    
    ArrayResize(ArrayData,NumStr);                                 //let us establish the size of massif in a quantity of the counted from the file lines
    for(text=0;text<NumStr;text++)
       {
        select=ArrayStrg[text]; 

//-------------------------------------------------------------------------
//                     Working the text of the report  (we separate flies from the cutlets)       
        //---------------------position is the passage------------------------------
        ClStep=StringFind(select, "; \">",20)+4;                                       //let us find the beginning of the position
        ClStepRazm=StringFind(select, "</td>",ClStep);                                 //let us find the end of the position
        CycleStep = StringSubstr(select, ClStep, ClStepRazm-ClStep);                   //we count the sum
        //----------------   -------------------------------
        GrProf=StringFind(select, "<td>",ClStepRazm);                                  //let us find the beginning of the position
        GrProfRazm=StringFind(select, "</td>",GrProf);                                 //let us find the end of the position
        GrossProfit = StringSubstr(select, GrProf+4,GrProfRazm-(GrProf+4));            //we count the sum
         //-------------   -----------------------------
        TotTrad=StringFind(select, "<td>",GrProfRazm);                                 //let us find the beginning of the position
        TotTradRazm=StringFind(select, "</td>",TotTrad);                               //let us find the end of the position
        TotalTrades = StringSubstr(select, TotTrad+4,TotTradRazm-(TotTrad+4));         //we count the sum
        //------------- --------------------------------
        ProfFact=StringFind(select, "<td>",TotTradRazm);                               //let us find the beginning of the position
        ProfFactRazm=StringFind(select, "</td>",ProfFact);                             //let us find the end of the position
        ProfitFactor = StringSubstr(select, ProfFact+4,ProfFactRazm-(ProfFact+4));     //we count the sum
       //-------------  ---------------------------------
        ExpPay=StringFind(select, "<td>",ProfFactRazm);                                //let us find the beginning of the position
        ExpPayRazm=StringFind(select, "</td>",ExpPay);                                 //let us find the end of the position
        ExpectedPayoff = StringSubstr(select, ExpPay+4,ExpPayRazm-(ExpPay+4));         //we count the sum
      
        //------------------------------------------------------------------
        
        //------------- ----------------------------------------
        P1=StringFind(select, Per1,20);                                                //let us find the beginning of the position
        P1k=StringFind(select, ";",P1);                                                //let us find the end of the position
        Perem1 = StringSubstr(select,P1+StringLen(Per1)+1,P1k-(P1+1+StringLen(Per1))); //we count the variable
        P2=StringFind(select, Per2,20);                                                //let us find the beginning of the position
        P2k=StringFind(select, ";",P2);                                                //let us find the end of the position
        Perem2 = StringSubstr(select,P2+StringLen(Per2)+1,P2k-(P2+1+StringLen(Per2))); //we count the variable
        P3=StringFind(select, Per3,20);                                                //let us find the beginning of the position
        P3k=StringFind(select, ";",P3);                                                //let us find the end of the position
        Perem3 = StringSubstr(select,P3+StringLen(Per3)+1,P3k-(P3+1+StringLen(Per3))); //we count the variable
        P4=StringFind(select, Per4,20);                                                //let us find the beginning of the position
        P4k=StringFind(select, ";",P4);                                                //let us find the end of the position
        Perem4 = StringSubstr(select,P4+StringLen(Per4)+1,P4k-(P4+1+StringLen(Per4))); //we count the variable
 //-----------------------let us transfer into the numerical size----------------------------
       TotalTradesTransit=StrToDouble(TotalTrades);
       if(MinTrades < TotalTradesTransit         )                    //let us filter out in a quantity of the transactions
           {
            PrFactDouble = StrToDouble(ProfitFactor);
            if(PrFactDouble==0){PrFactDouble=1000;}                    //we remove 0 in the profitableness for the correct analysis
            ArrayData[text][1]=StrToDouble(GrossProfit);                                
            ArrayData[text][2]=TotalTradesTransit;
            ArrayData[text][3]=PrFactDouble;
            ArrayData[text][4]=StrToDouble(ExpectedPayoff);
            ArrayData[text][5]=StrToDouble(Perem1);
            ArrayData[text][6]=StrToDouble(Perem2);
            ArrayData[text][7]=StrToDouble(Perem3);
            ArrayData[text][8]=StrToDouble(Perem4);
            ResizeArayNew++; 
            }
       }
 
 //------------------------------the analyzer---------------------------------------------------------------      
   ArraySort(ArrayData,ResizeArayNew,0,MODE_DESCEND); 
   ArrayResize(ArrayTrans, ResizeArayNew-1);
           
   for(int PrioStep=1;PrioStep<4;PrioStep++)
      { 
       for(PrCycle=0;PrCycle<ResizeArayNew;PrCycle++)
          { 
           Sort     = ArrayData[PrCycle][0];
           Prior1   = ArrayData[PrCycle][1];             
           transit  = ArrayData[PrCycle][2];
           Prior2   = ArrayData[PrCycle][3];             
           Prior3   = ArrayData[PrCycle][4];             
           transit1 = ArrayData[PrCycle][5];
           transit2 = ArrayData[PrCycle][6];
           transit3 = ArrayData[PrCycle][7];
           transit4 = ArrayData[PrCycle][8]; 
        
           if(PrioStep==1)
             {
              //let us be prepared for 1 sorting
              if(Gross_Profit   ==1){SortTrans=Prior1;}
              if(Profit_Factor  ==1){SortTrans=Prior2;}
              if(Expected_Payoff==1){SortTrans=Prior3;}
             }

           if(PrioStep==2)
             {
              //let us be restored
              if(Gross_Profit   ==1){Prior1=Sort;}
              if(Profit_Factor  ==1){Prior2=Sort;}
              if(Expected_Payoff==1){Prior3=Sort;} 
              
              //let us be prepared for 2 sortings
              if(Gross_Profit   ==2){SortTrans=Prior1;}
              if(Profit_Factor  ==2){SortTrans=Prior2;}
              if(Expected_Payoff==2){SortTrans=Prior3;}
             }
           if(PrioStep==3)
             {
              //let us be restored
              if(Gross_Profit   ==2){Prior1=Sort;}
              if(Profit_Factor  ==2){Prior2=Sort;}
              if(Expected_Payoff==2){Prior3=Sort;} 
              
              //let us be prepared for 3 sortings
              if(Gross_Profit   ==3){SortTrans=Prior1;}
              if(Profit_Factor  ==3){SortTrans=Prior2;}
              if(Expected_Payoff==3){SortTrans=Prior3;}
             }          
    
           ArrayTrans[PrCycle][0] = SortTrans;
           ArrayTrans[PrCycle][1] = Prior1;
           ArrayTrans[PrCycle][2] = transit;
           ArrayTrans[PrCycle][3] = Prior2;
           ArrayTrans[PrCycle][4] = Prior3;
           ArrayTrans[PrCycle][5] = transit1;
           ArrayTrans[PrCycle][6] = transit2;
           ArrayTrans[PrCycle][7] = transit3;
           ArrayTrans[PrCycle][8] = transit4;
          }
          ArraySort(ArrayTrans,StepRes,0,MODE_DESCEND);               //let us sort out the massif
          ArrayResize(ArrayData,StepRes);                             //let us cut excess
          ArrayResize(ArrayTrans,StepRes);                            //let us cut excess
          for(int CopyAr=0;CopyAr<StepRes;CopyAr++)
             {
              ArrayData[CopyAr][0]=ArrayTrans[CopyAr][0];
              ArrayData[CopyAr][1]=ArrayTrans[CopyAr][1];
              ArrayData[CopyAr][2]=ArrayTrans[CopyAr][2];
              ArrayData[CopyAr][3]=ArrayTrans[CopyAr][3];
              ArrayData[CopyAr][4]=ArrayTrans[CopyAr][4];             
              ArrayData[CopyAr][5]=ArrayTrans[CopyAr][5];             //Per1    Variable 1 
              ArrayData[CopyAr][6]=ArrayTrans[CopyAr][6];             //Per2    Variable 2
              ArrayData[CopyAr][7]=ArrayTrans[CopyAr][7];             //Per3    Variable 3
              ArrayData[CopyAr][8]=ArrayTrans[CopyAr][8];             //Per4    Variable 4
 
             }
         
           StepRes=StepRes/2;
          }
//--------------------- the record of the new parameters in the variables --------
       FastEMA      = ArrayTrans[0][5];                               
       SlowEMA      = ArrayTrans[0][6];
       TakeProfit   = ArrayTrans[0][7];
       TrailingStop = ArrayTrans[0][8];
       
       Comment(Per1," ",FastEMA,"  | ",Per2," ",SlowEMA,"  | ",Per3," ",TakeProfit,"  | ",Per4," ",TrailingStop);
       Print(Per1," ",FastEMA,"  | ",Per2," ",SlowEMA,"  | ",Per3," ",TakeProfit,"  | ",Per4," ",TrailingStop);

     return;

      }  //the end of the function 
 

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~




int start()
  {
   double MacdCurrent, MacdPrevious, SignalCurrent;
   double SignalPrevious, MaCurrent, MaPrevious;
   int cnt, ticket, total;
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
  // if(TakeProfit<10)
  //   {
  //    Print("TakeProfit less than 10");
  //    return(0);  // check TakeProfit
  //   }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//------------------- 1 time in a 24 hour period let us are optimized on the history and we establish the parameters--------------------------------

if(!IsOptimization()||!IsTesting())               // not to start in the regime of optimization and testing
  {  
   double TimeLoc = StrToDouble(TimeToStr(TimeLocal(),TIME_MINUTES))+(Minute()*0.01); //the current time

   if(Flag == 0 && TimeLoc >= TimeTest && TimeLoc < TimeTest+5){Flag = 1;Tester();}
   if(TimeLoc > TimeTest+0.15){Flag = 0;}            //if from the moment of starting past it is more than 15 minutes that let us reset to zero the flag
   Comment(TimeLoc," <> ",TimeTest,"   ",TimeTest-TimeLoc,"\n",Per1," ",FastEMA,"  | ",Per2," ",SlowEMA,"  | ",Per3," ",TakeProfit,"  | ",Per4," ",TrailingStop);

  }
 
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     
// to simplify the coding and speed up access
// data are put into internal variables
   MacdCurrent=iMACD(NULL,0,FastEMA,SlowEMA,9,PRICE_CLOSE,MODE_MAIN,0);
   MacdPrevious=iMACD(NULL,0,FastEMA,SlowEMA,9,PRICE_CLOSE,MODE_MAIN,1);
   SignalCurrent=iMACD(NULL,0,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,0);
   SignalPrevious=iMACD(NULL,0,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,1);
   MaCurrent=iMA(NULL,0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,0);
   MaPrevious=iMA(NULL,0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,1);

   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      // check for long position (BUY) possibility
      if(MacdCurrent<0 && MacdCurrent>SignalCurrent && MacdPrevious<SignalPrevious &&
         MathAbs(MacdCurrent)>(MACDOpenLevel*pointvalue) && MaCurrent>MaPrevious)
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*pointvalue,"macd sample",16384,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // check for short position (SELL) possibility
      if(MacdCurrent>0 && MacdCurrent<SignalCurrent && MacdPrevious>SignalPrevious && 
         MathAbs(MacdCurrent)>(MACDOpenLevel*pointvalue) && MaCurrent<MaPrevious)
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,Bid-TakeProfit*pointvalue,"macd sample",16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if(MacdCurrent>0 && MacdCurrent<SignalCurrent && MacdPrevious>SignalPrevious &&
               MathAbs(MacdCurrent)>(MACDCloseLevel*pointvalue))
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>pointvalue*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-pointvalue*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-pointvalue*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // should it be closed?
            if(MacdCurrent<0 && MacdCurrent>SignalCurrent && MacdPrevious<SignalPrevious && 
               MathAbs(MacdCurrent)>(MACDCloseLevel*pointvalue))
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(pointvalue*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+pointvalue*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+pointvalue*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
// the end.



/*
Instruction on the installation.

Thus for the starting it will be required us:
1) the pair of terminals [MT]4 in this case on that where we will start optimization it must
to be shaken the history of quotations for entire necessary period.
Let us name them so that not they [putatsya] - the terminal and terminal tester
Further
2) let us copy the files of the expert OF MACD Of sample2.1.mq4 and 
MACD Of sample2.1.ex4 into the folders with the experts - into the folder 
where terminal
and into the folder where the terminal tester.
3) let us neglect terminal tester, and let us neglect the tester of 
strategies, in the properties of expert it is necessary to prepare the 
version of the optimization
(to establish the parameters of variables which we want to optimize not
 more - 4 variables) and to preserve into the file with the name - MACDSample2. 1. set
so the names of these variables must be written down
in the division - names of variables for the optimization and in the 
division the record of the new parameters in the variables
4) it is now necessary in the division local variables to indicate way 
to terminal tester " [u]
for this instead of the line D:\Program Files\MetaTrader - Masterforex; 
it is necessary to write way to the folder with that established in you
the terminal tester " of ohms.
(All these complexities in the preparation are connected
1. with the impossibility of work with the external files from the expert
2. by impossibility of simultaneous starting of one and that - terminal)
All now it is possible to start the expert OF MACD Of sample2.1.ex4 - as 
having usually hung him to the graph.
with the first starting expert to [srazu]-[zhe] will neglect terminal tester will 
conduct optimization and he will write down the obtained values into the selected variables
further expert will be started each twenty-four hours in the time indicated
in the left upper angle it is possible to see the instantaneous values of the 
selected variables, and so the current time, established
the time of conducting optimization.

well and the fastened file strictly 

*/